## mingw-w64-gr-0.73.7-2.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
include(GetVersionFromGit)
get_version_from_git(GR_VERSION GR_VERSION_FULL)

project(
  GR
  VERSION ${GR_VERSION}
  LANGUAGES C CXX
)

include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

# Honor `C_VISIBILITY_PRESET hidden` and `CXX_VISIBILITY_PRESET hidden` in static libraries
cmake_policy(SET CMP0063 NEW)

check_cxx_compiler_flag("-Werror=implicit" ERROR_IMPLICIT_SUPPORTED)
if(ERROR_IMPLICIT_SUPPORTED)
  set(COMPILER_OPTION_ERROR_IMPLICIT
      "-Werror=implicit"
      CACHE INTERNAL "Compiler flag for generating errors on implicit declarations"
  )
else()
  set(COMPILER_OPTION_ERROR_IMPLICIT
      ""
      CACHE INTERNAL "Compiler flag for generating errors on implicit declarations"
  )
endif()

if(UNIX)
  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX
        "/usr/local/gr"
        CACHE PATH "GR install prefix" FORCE
    )
  endif()
endif()
set(GR_DIRECTORY
    "${CMAKE_INSTALL_PREFIX}"
    CACHE STRING "Default value for GRDIR"
)
option(GR_BUILD_DEMOS "Build demos for GR" OFF)
option(GR_INSTALL "Create installation target for GR" ON)
option(GR_USE_BUNDLED_LIBRARIES "Use thirdparty libraries bundled with GR" OFF)
option(GR_MANUAL_MOC_AND_RCC "Manually run moc and rcc instead of relying on AUTOMOC and AUTORCC" OFF)
option(GR_FIND_QT5_BY_VARIABLES "Find Qt5 based on the variables Qt5_INCLUDE_DIR and Qt5_LIBRARY_DIR" OFF)
option(GR_PREFER_XCODEBUILD "Prefer xcodebuild to build macOS applications if available" ON)

if(GR_USE_BUNDLED_LIBRARIES)
  list(APPEND CMAKE_FIND_ROOT_PATH "${CMAKE_CURRENT_LIST_DIR}/3rdparty/build/")
  set(GR_THIRDPARTY_LIBRARY_PREFIX ${CMAKE_STATIC_LIBRARY_PREFIX})
  set(GR_THIRDPARTY_LIBRARY_SUFFIX ${CMAKE_STATIC_LIBRARY_SUFFIX})
else()
  set(GR_THIRDPARTY_LIBRARY_PREFIX ${CMAKE_SHARED_LIBRARY_PREFIX})
  set(GR_THIRDPARTY_LIBRARY_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

if(GR_FIND_QT5_BY_VARIABLES)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/optional/qt5")
endif()

if(WIN32)
  set(GR_PLUGIN_SUFFIX ".dll")
else()
  set(GR_PLUGIN_SUFFIX ".so")
endif()

if(APPLE)
  set(DEFAULT_SHARED_LIBRARY_SUFFIX ".dylib")
else()
  set(DEFAULT_SHARED_LIBRARY_SUFFIX "${GR_PLUGIN_SUFFIX}")
endif()

set(GR_SHARED_LIBRARY_SUFFIX
    "${DEFAULT_SHARED_LIBRARY_SUFFIX}"
    CACHE STRING "File suffix for shared libraries"
)

set(CMAKE_FIND_PACKAGE_PREFER_CONFIG
    TRUE
    CACHE BOOL ""
)

# Find the following packages always in system locations even if `GR_USE_BUNDLED_LIBRARIES` is set, because they are not
# located in 3rdparty
find_package(X11)
find_package(Fontconfig)
find_package(OpenGL OPTIONAL_COMPONENTS OpenGL)
if(${CMAKE_VERSION} VERSION_GREATER "3.16.0")
  find_package(
    Qt6
    OPTIONAL_COMPONENTS
      Widgets
      Core
      Network
      Gui
      PrintSupport
  )
endif()
find_package(
  Qt5
  OPTIONAL_COMPONENTS
    Widgets
    Core
    Network
    Gui
    PrintSupport
)
find_package(Qt4)

# Find the following packages only in 3rdparty, if `GR_USE_BUNDLED_LIBRARIES` is set
if(GR_USE_BUNDLED_LIBRARIES)
  set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM ONLY)
endif()
find_package(Freetype)
if(TARGET freetype AND NOT TARGET Freetype::Freetype)
  add_library(Freetype::Freetype ALIAS freetype)
endif()
find_package(Jpeg REQUIRED)
find_package(Libpng REQUIRED)
find_package(ZLIB REQUIRED)
find_package(Qhull REQUIRED)
if(TARGET Qhull::qhullstatic_r AND NOT TARGET Qhull::qhull_r)
  add_library(Qhull::qhull_r ALIAS Qhull::qhullstatic_r)
endif()
find_package(Tiff)
find_package(Ffmpeg 57.48.100)
find_package(glfw3)
if(TARGET glfw AND NOT TARGET Glfw::Glfw)
  add_library(Glfw::Glfw ALIAS glfw)
endif()
find_package(ZeroMQ)
if(NOT TARGET ZeroMQ::ZeroMQ)
  if(TARGET libzmq)
    add_library(ZeroMQ::ZeroMQ ALIAS libzmq)
  elseif(TARGET libzmq-static)
    add_library(ZeroMQ::ZeroMQ ALIAS libzmq-static)
    get_target_property(ZeroMQ_LIBRARY libzmq-static LOCATION)
  endif()
endif()
find_package(Cairo)
find_package(Agg)
find_package(Gs)
find_package(XercesC)

if(APPLE)
  set(INSTALL_RPATH "${GR_DIRECTORY}/lib/;@loader_path/.")
else()
  set(INSTALL_RPATH "${GR_DIRECTORY}/lib/;$ORIGIN/.")
endif()

if(Qt4_FOUND
   OR (Qt5Widgets_FOUND
       AND Qt5Core_FOUND
       AND Qt5Network_FOUND
      )
   OR (Qt6Widgets_FOUND
       AND Qt6Core_FOUND
       AND Qt6Network_FOUND
      )
)
  if(GR_MANUAL_MOC_AND_RCC)
    if(NOT QT_MOC_EXECUTABLE)
      find_program(QT_MOC_EXECUTABLE moc CMAKE_FIND_ROOT_PATH_BOTH)
    endif()
    if(NOT QT_MOC_EXECUTABLE)
      message(FATAL_ERROR "Could not find moc but GR_MANUAL_MOC_AND_RCC is set.")
    endif()
    if(NOT QT_RCC_EXECUTABLE)
      find_program(QT_RCC_EXECUTABLE rcc CMAKE_FIND_ROOT_PATH_BOTH)
    endif()
    if(NOT QT_RCC_EXECUTABLE)
      message(FATAL_ERROR "Could not find rcc but GR_MANUAL_MOC_AND_RCC is set.")
    endif()
  endif()
endif()
if(Qt4_FOUND)
  set(QT4_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS QT_INCLUDE_DIR)
    set(QT4_MOC_INCLUDE_FLAGS ${QT4_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt4_LIBRARY_DIR)
    get_filename_component(Qt4_LIBRARY_DIR "${QT_LIBRARY_DIR}/../.." ABSOLUTE)
  endif()
endif()
if(Qt5Widgets_FOUND
   AND Qt5Core_FOUND
   AND Qt5Network_FOUND
)
  set(QT5_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS Qt5Core_INCLUDE_DIRS Qt5Gui_INCLUDE_DIRS Qt5Widgets_INCLUDE_DIRS)
    set(QT5_MOC_INCLUDE_FLAGS ${QT5_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt5_LIBRARY_DIR)
    get_filename_component(Qt5_LIBRARY_DIR "${Qt5_DIR}/../.." ABSOLUTE)
  endif()
endif()
if(Qt6Widgets_FOUND
   AND Qt6Core_FOUND
   AND Qt6Network_FOUND
)
  set(QT6_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS Qt6Core_INCLUDE_DIRS Qt6Gui_INCLUDE_DIRS Qt6Widgets_INCLUDE_DIRS)
    set(QT6_MOC_INCLUDE_FLAGS ${QT6_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt6_LIBRARY_DIR)
    get_filename_component(Qt6_LIBRARY_DIR "${Qt6_DIR}/../.." ABSOLUTE)
  endif()
endif()

if(X11_FOUND)
  # older versions of FindX11.cmake set variables but do not create targets
  if(NOT TARGET X11::X11
     AND X11_INCLUDE_DIR
     AND X11_X11_LIB
     AND X11_Xft_LIB
  )
    add_library(X11::X11 UNKNOWN IMPORTED)
    set_target_properties(
      X11::X11
      PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${X11_INCLUDE_DIR}/"
                 IMPORTED_LINK_INTERFACE_LANGUAGES "C"
                 IMPORTED_LOCATION "${X11_X11_LIB}"
                 INTERFACE_LINK_LIBRARIES "${X11_Xft_LIB}"
    )
  endif()
  if(NOT TARGET X11::Xt
     AND X11_INCLUDE_DIR
     AND X11_Xt_LIB
     AND TARGET X11::X11
  )
    add_library(X11::Xt UNKNOWN IMPORTED)
    set_target_properties(
      X11::Xt
      PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${X11_INCLUDE_DIR}/"
                 IMPORTED_LINK_INTERFACE_LANGUAGES "C"
                 IMPORTED_LOCATION "${X11_Xt_LIB}"
                 INTERFACE_LINK_LIBRARIES "X11::X11"
    )
  endif()
endif()

set(GKS_SOURCES
    lib/gks/afm.c
    lib/gks/font.c
    lib/gks/socket.c
    lib/gks/ft.c
    lib/gks/malloc.c
    lib/gks/util.c
    lib/gks/compress.c
    lib/gks/gks.c
    lib/gks/mf.c
    lib/gks/win.c
    lib/gks/gksforbnd.c
    lib/gks/pdf.c
    lib/gks/wiss.c
    lib/gks/dl.c
    lib/gks/plugin.c
    lib/gks/error.c
    lib/gks/io.c
    lib/gks/ps.c
    lib/gks/resample.c
)

add_library(gks_static STATIC ${GKS_SOURCES})
add_library(gks_shared SHARED ${GKS_SOURCES})

foreach(LIBRARY gks_static gks_shared)
  if(LIBRARY MATCHES "static")
    set(GKS_LINK_MODE PUBLIC)
  else()
    set(GKS_LINK_MODE PRIVATE)
  endif()
  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_definitions(${LIBRARY} PRIVATE _CRT_SECURE_NO_WARNINGS)
  endif()
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} pthread)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} m)
  endif()
  if(FREETYPE_FOUND)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} Freetype::Freetype)
  else()
    target_compile_definitions(
      ${LIBRARY}
      ${GKS_LINK_MODE}
      NO_FT
    )
  endif()
  target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} ZLIB::ZLIB)
  target_compile_definitions(
    ${LIBRARY}
    ${GKS_LINK_MODE}
    HAVE_ZLIB
  )
  if(UNIX)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} dl)
  elseif(WIN32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} ws2_32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} msimg32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} gdi32)
  endif()
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    target_compile_options(${LIBRARY} ${GKS_LINK_MODE} -pthread)
  endif()
  target_compile_options(${LIBRARY} PRIVATE ${COMPILER_OPTION_ERROR_IMPLICIT})
  target_include_directories(
    ${LIBRARY} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib/gks/>
                      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )
  target_compile_definitions(${LIBRARY} PRIVATE GRDIR="${GR_DIRECTORY}")
  set_target_properties(
    ${LIBRARY}
    PROPERTIES C_STANDARD 90
               C_EXTENSIONS OFF
               C_STANDARD_REQUIRED ON
               POSITION_INDEPENDENT_CODE ON
               PREFIX "lib"
               IMPORT_PREFIX "lib"
               OUTPUT_NAME GKS
               INSTALL_RPATH "${INSTALL_RPATH}"
  )
endforeach()
unset(GKS_LINK_MODE)
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  set_target_properties(gks_static PROPERTIES OUTPUT_NAME GKSstatic)
endif()
set_target_properties(gks_shared PROPERTIES SUFFIX "${GR_SHARED_LIBRARY_SUFFIX}" EXPORT_NAME GKS)
add_library(GR::GKS ALIAS gks_static)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/gr_version.h
     "#ifndef GR_VERSION\n#define GR_VERSION \"${GR_VERSION_FULL}\"\n#endif\n"
)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/gr_version.h PROPERTIES GENERATED TRUE)

set(GR_SOURCES
    lib/gr/boundary.c
    lib/gr/contour.c
    lib/gr/contourf.c
    lib/gr/delaunay.c
    lib/gr/gr.c
    lib/gr/grforbnd.c
    lib/gr/gridit.c
    lib/gr/image.c
    lib/gr/import.c
    lib/gr/interp2.c
    lib/gr/stream.c
    lib/gr/md5.c
    lib/gr/shade.c
    lib/gr/spline.c
    lib/gr/strlib.c
    lib/gr/text.c
    lib/gr/mathtex2.c
    lib/gr/mathtex2_kerning.c
    lib/gr/mathtex2.tab.c
    lib/gr/threadpool.c
    ${CMAKE_CURRENT_BINARY_DIR}/gr_version.h
)

add_library(gr_static STATIC ${GR_SOURCES})
add_library(gr_shared SHARED ${GR_SOURCES})

foreach(LIBRARY gr_static gr_shared)
  if(LIBRARY MATCHES "static")
    set(GR_LINK_MODE PUBLIC)
  else()
    set(GR_LINK_MODE PRIVATE)
  endif()
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} gks_static)
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    target_link_libraries(${LIBRARY} ${GR_LINK_MODE} m)
  endif()
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} Qhull::qhull_r)
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} Jpeg::Jpeg)
  target_link_libraries(${LIBRARY} ${GR_LINK_MODE} Libpng::Libpng)
  if(WIN32)
    target_link_libraries(${LIBRARY} ${GR_LINK_MODE} ws2_32)
  endif()
  target_include_directories(
    ${LIBRARY} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib/gr/>
                      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )
  target_include_directories(${LIBRARY} PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_definitions(${LIBRARY} PRIVATE _CRT_SECURE_NO_WARNINGS)
  endif()
  target_compile_definitions(${LIBRARY} PRIVATE GRDIR="${GR_DIRECTORY}")
  target_compile_options(${LIBRARY} PRIVATE ${COMPILER_OPTION_ERROR_IMPLICIT})
  set_target_properties(
    ${LIBRARY}
    PROPERTIES C_STANDARD 90
               C_EXTENSIONS OFF
               C_STANDARD_REQUIRED ON
               POSITION_INDEPENDENT_CODE ON
               INSTALL_RPATH "${INSTALL_RPATH}"

=== 3rdparty/Makefile ===
UNAME := $(shell uname)

 TARGETS = freetype jpeg libpng16 zlib qhull bzip2
ifeq ($(UNAME), Darwin)
 TARGETS += zeromq
endif
  EXTRAS = agg tiff ogg theora vpx openh264 ffmpeg glfw zeromq pixman cairo icu xerces-c
     DIR =

default:
	@set -e; for d in $(TARGETS); do $(MAKE) -C $$d PREFIX=$(DIR); done

extras:
	@set -e; for d in $(EXTRAS); do $(MAKE) -C $$d PREFIX=$(DIR); done

clean:
	@set -e; for d in $(TARGETS); do $(MAKE) -C $$d clean; done

realclean: clean
	rm -rf ./build

.PHONY: default extras clean realclean

=== js/Makefile ===
ifeq ($(strip $(THIRDPARTYDIR)),)
override THIRDPARTYDIR = $(abspath $(CURDIR)/../3rdparty/build)
endif

ifneq ($(notdir $(CC)),emcc)
rerun_with_emmake:
	 emmake make
endif

OPTS = \
		-s ERROR_ON_UNDEFINED_SYMBOLS=0 \
		-s LEGACY_GL_EMULATION=1 \
		-s 'EXTRA_EXPORTED_RUNTIME_METHODS=["ccall", "cwrap", "getValue", "setValue", "addFunction", "removeFunction", "UTF8ToString", "stringToUTF8", "lengthBytesUTF8"]' \
		-s NO_EXIT_RUNTIME=0 \
		-s WASM=0 \
		--memory-init-file 0 \
		-s TOTAL_MEMORY=33554432 \
		-s ALLOW_MEMORY_GROWTH=1 \
		-s RESERVED_FUNCTION_POINTERS=4 \
		-s ALLOW_TABLE_GROWTH=1 \
		--no-heap-copy \
		-s USE_ICU=1
ifndef DEBUG
    OPTS  += -O3
else
    OPTS  += -s ASSERTIONS=2 -s SAFE_HEAP=1 -s STACK_OVERFLOW_CHECK=2
endif
   DEFINES = -DEMSCRIPTEN -D__SVR4 -DGRDIR=\"\" -DNO_GL -DNO_THREADS
    CFLAGS = $(DEFINES) $(OPTS) $(EXTRA_CFLAGS)
  CXXFLAGS = $(DEFINES) $(OPTS) -std=c++17 $(EXTRA_CXXFLAGS)
   LDFLAGS = $(DEFINES) $(OPTS) $(EXTRA_LDFLAGS)
   JPEGDIR = ../3rdparty/jpeg
    PNGDIR = ../3rdparty/libpng16
   ZLIBDIR = ../3rdparty/zlib
  QHULLDIR = ../3rdparty/qhull
     FTDIR = ../3rdparty/freetype
XERCESCDIR = ../3rdparty/xerces-c
    GKSDIR = ../lib/gks
     GRDIR = ../lib/gr
    GR3DIR = ../lib/gr3
    GRMDIR = ../lib/grm
  INCLUDES = -I$(THIRDPARTYDIR)/include/ \
             -I$(GRMDIR)/include \
             -I$(GRMDIR)/src \
             -I$(GR3DIR) \
             -I$(GRDIR) \
             -I$(GKSDIR) \
             -I$(JPEGDIR) \
             -I$(PNGDIR) \
             -I$(ZLIBDIR) \
             -I$(QHULLDIR) \
             -I$(FTDIR)
   GKSOBJS = jsplugin.o \
             $(GKSDIR)/afm.o \
             $(GKSDIR)/error.o \
             $(GKSDIR)/font.o \
             $(GKSDIR)/ft.o \
             $(GKSDIR)/gks.o \
             $(GKSDIR)/io.o \
             $(GKSDIR)/malloc.o \
             $(GKSDIR)/util.o \
             $(GKSDIR)/wiss.o
    GROBJS = $(GRDIR)/contour.o \
             $(GRDIR)/contourf.o \
             $(GRDIR)/delaunay.o \
             $(GRDIR)/gr.o \
             $(GRDIR)/grforbnd.o \
             $(GRDIR)/gridit.o \
             $(GRDIR)/image.o \
             $(GRDIR)/import.o \
             $(GRDIR)/interp2.o \
             $(GRDIR)/mathtex2.o \
             $(GRDIR)/mathtex2.tab.o \
             $(GRDIR)/mathtex2_kerning.o \
             $(GRDIR)/md5.o \
             $(GRDIR)/shade.o \
             $(GRDIR)/spline.o \
             $(GRDIR)/stream.o \
             $(GRDIR)/strlib.o \
             $(GRDIR)/text.o
   GR3OBJS = $(GR3DIR)/gr3.o \
             $(GR3DIR)/gr3_convenience.o \
             $(GR3DIR)/gr3_gr.o \
             $(GR3DIR)/gr3_html.o \
             $(GR3DIR)/gr3_jpeg.o \
             $(GR3DIR)/gr3_mc.o \
             $(GR3DIR)/gr3_png.o \
             $(GR3DIR)/gr3_povray.o \
             $(GR3DIR)/gr3_sr.o
   GRMOBJS = $(GRMDIR)/src/grm/args.o \
             $(GRMDIR)/src/grm/backtrace.o \
             $(GRMDIR)/src/grm/base64.o \
             $(GRMDIR)/src/grm/dump.o \
             $(GRMDIR)/src/grm/dynamic_args_array.o \
             $(GRMDIR)/src/grm/error.o \
             $(GRMDIR)/src/grm/event.o \
             $(GRMDIR)/src/grm/interaction.o \
             $(GRMDIR)/src/grm/json.o \
             $(GRMDIR)/src/grm/layout.o \
             $(GRMDIR)/src/grm/layout_c.o \
             $(GRMDIR)/src/grm/layout_error.o \
             $(GRMDIR)/src/grm/logging.o \
             $(GRMDIR)/src/grm/memwriter.o \
             $(GRMDIR)/src/grm/net.o \
             $(GRMDIR)/src/grm/plot.o \
             $(GRMDIR)/src/grm/util.o \
             $(GRMDIR)/src/grm/utilcpp.o \
             $(GRMDIR)/src/grm/import.o \
             $(GRMDIR)/src/grm/datatype/double_map.o \
             $(GRMDIR)/src/grm/datatype/size_t_list.o \
             $(GRMDIR)/src/grm/datatype/string_array_map.o \
             $(GRMDIR)/src/grm/datatype/string_list.o \
             $(GRMDIR)/src/grm/datatype/string_map.o \
             $(GRMDIR)/src/grm/datatype/uint_map.o \
             $(GRMDIR)/src/grm/dom_render/context.o \
             $(GRMDIR)/src/grm/dom_render/Drawable.o \
             $(GRMDIR)/src/grm/dom_render/ManageCustomColorIndex.o \
             $(GRMDIR)/src/grm/dom_render/ManageGRContextIds.o \
             $(GRMDIR)/src/grm/dom_render/ManageZIndex.o \
             $(GRMDIR)/src/grm/dom_render/render.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Comment.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Document.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Element.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Node.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/Value.o \
             $(GRMDIR)/src/grm/dom_render/graphics_tree/util.o
      OBJS = $(GRMOBJS) $(GR3OBJS) $(GROBJS) $(GKSOBJS)
      LIBS = $(JPEGDIR)/libjpeg.a \
             $(PNGDIR)/libpng.a \
             $(ZLIBDIR)/libz.a \
             $(QHULLDIR)/libqhull_r.a \
             $(FTDIR)/libfreetype.a \
             $(XERCESCDIR)/libxerces-c.a

.PHONY: default clean .SECONDARY .FORCE

.SUFFIXES:
.SUFFIXES: .c .cxx .o

.SECONDARY:

.FORCE:

default: gr.js

../lib/gr/gr_version.h: .FORCE
	$(MAKE) -C ../lib/gr gr_version.h

gr.js: module.js libGR.js api.js jsterm.js
	cat $^ > $@

fonts:
	mkdir fonts
	cp -p $(GKSDIR)/fonts/CMUSerif-Math.ttf $(GKSDIR)/fonts/DejaVuSans.ttf $(GKSDIR)/fonts/STIXTwoMath.ttf $(GKSDIR)/fonts/gksfont.dat $(GKSDIR)/fonts/mathtex2_offsets.bin fonts/

$(JPEGDIR)/libjpeg.a:
	$(MAKE) -C $(JPEGDIR)

$(PNGDIR)/libpng.a:
	$(MAKE) -C $(PNGDIR)

$(ZLIBDIR)/libz.a:
	$(MAKE) -C $(ZLIBDIR)

$(QHULLDIR)/libqhull_r.a:
	$(MAKE) -C $(QHULLDIR)

$(FTDIR)/libfreetype.a:
	$(MAKE) -C $(FTDIR)

$(XERCESCDIR)/libxerces-c.a:
	$(MAKE) -C $(XERCESCDIR) libxerces-c.a

$(GRDIR)/gr.o: ../lib/gr/gr_version.h

%.o: %.c $(LIBS)
	$(CC) -c $(CFLAGS) -o $@ $< $(INCLUDES)

%.o: %.cxx $(LIBS)
	$(CXX) -c $(CXXFLAGS) -o $@ $< $(INCLUDES)

libGR.js: $(OBJS) $(LIBS) library.js fonts
	$(CXX) $(LDFLAGS) \
	--embed-file fonts/gksfont.dat --embed-file fonts/CMUSerif-Math.ttf --embed-file fonts/DejaVuSans.ttf --embed-file fonts/STIXTwoMath.ttf --embed-file fonts/mathtex2_offsets.bin \
	--js-library library.js \
	-o $@ $(OBJS) $(LIBS) \
	-s EXPORTED_FUNCTIONS="['_gr_opengks', '_gr_closegks', '_gr_inqdspsize', '_gr_openws', '_gr_closews', '_gr_activatews', '_gr_deactivatews', '_gr_clearws', '_gr_updatews', '_gr_polyline', '_gr_polymarker', '_gr_text', '_gr_inqtext', '_gr_fillarea', '_gr_cellarray', '_gr_spline', '_gr_gridit', '_gr_setlinetype', '_gr_inqlinetype', '_gr_setlinewidth', '_gr_inqlinewidth', '_gr_setlinecolorind', '_gr_inqlinecolorind', '_gr_setmarkertype', '_gr_inqmarkertype', '_gr_setmarkersize', '_gr_setmarkercolorind', '_gr_inqmarkercolorind', '_gr_settextfontprec', '_gr_setcharexpan', '_gr_setcharspace', '_gr_settextcolorind', '_gr_setcharheight', '_gr_setcharup', '_gr_settextpath', '_gr_settextalign', '_gr_setfillintstyle', '_gr_setfillstyle', '_gr_setfillcolorind', '_gr_setcolorrep', '_gr_setscale', '_gr_inqscale', '_gr_setwindow', '_gr_inqwindow', '_gr_setviewport', '_gr_inqviewport', '_gr_selntran', '_gr_setclip', '_gr_setwswindow', '_gr_setwsviewport', '_gr_createseg', '_gr_copysegws', '_gr_redrawsegws', '_gr_setsegtran', '_gr_closeseg', '_gr_emergencyclosegks', '_gr_updategks', '_gr_setspace', '_gr_inqspace', '_gr_textext', '_gr_inqtextext', '_gr_setscientificformat', '_gr_axes', '_gr_grid', '_gr_verrorbars', '_gr_herrorbars', '_gr_polyline3d', '_gr_axes3d', '_gr_titles3d', '_gr_surface', '_gr_contour', '_gr_hexbin', '_gr_setcolormap', '_gr_inqcolormap', '_gr_colorbar', '_gr_inqcolor', '_gr_inqcolorfromrgb', '_gr_hsvtorgb', '_gr_tick', '_gr_validaterange', '_gr_adjustrange', '_gr_beginprint', '_gr_beginprintext', '_gr_endprint', '_gr_ndctowc', '_gr_wctondc', '_gr_drawrect', '_gr_fillrect', '_gr_drawarc', '_gr_fillarc', '_gr_drawpath', '_gr_setarrowstyle', '_gr_drawarrow', '_gr_readimage', '_gr_drawimage', '_gr_importgraphics', '_gr_setshadow', '_gr_settransparency', '_gr_setcoordxform', '_gr_begingraphics', '_gr_endgraphics', '_gr_drawgraphics', '_gr_mathtex', '_gr_beginselection', '_gr_endselection', '_gr_moveselection', '_gr_resizeselection', '_gr_inqbbox', '_gr_precision', '_gr_setregenflags', '_gr_inqregenflags', '_gr_savestate', '_gr_restorestate', '_gr_selectcontext', '_gr_destroycontext', '_gr_uselinespec', '_gr_selntran', '_gks_get_dash_list', '_gr_shade', '_gr_shadepoints', '_gr_shadelines', '_gr_panzoom', '_gr_path', '_gr_setborderwidth', '_gr_inqborderwidth', '_gr_setbordercolorind', '_gr_inqbordercolorind', '_gr_selectclipxform', '_gr_inqclipxform', '_gr_settextencoding', '_grm_read', '_grm_args_new', '_grm_args_push', '_grm_args_delete', '_grm_plot', '_grm_get_stdout', '_grm_dump_json', '_grm_dump', '_grm_input', '_grm_merge', '_grm_merge_named', '_grm_switch', '_grm_get_box', '_grm_get_tooltip', '_grm_register', '_grm_unregister', '_grm_dump_json_str', '_grm_load_from_str', '_grm_is3d']"

clean:
	rm -f libGR.js gr.js *.js.mem
	rm -rf fonts
	cd $(JPEGDIR) && make clean
	cd $(PNGDIR) && make clean
	cd $(ZLIBDIR) && make clean
	cd $(QHULLDIR) && make clean
	cd $(FTDIR) && make clean
	cd $(XERCESCDIR) && make clean
	rm -rf $(OBJS)

=== 3rdparty/agg/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

 CXXFLAGS = -Wall -pedantic -O -Iinclude -std=c++11 -fPIC -fno-common $(ARCHS)
ifeq ($(UNAME),Darwin)
CXXFLAGS += -mmacosx-version-min=10.11
endif
     OBJS = agg_arc.o \
        agg_arrowhead.o \
        agg_bezier_arc.o \
        agg_bspline.o \
        agg_color_rgba.o \
        agg_curves.o \
        agg_embedded_raster_fonts.o \
        agg_gsv_text.o \
        agg_image_filters.o \
        agg_line_aa_basics.o \
        agg_line_profile_aa.o \
        agg_rounded_rect.o \
        agg_sqrt_tables.o \
        agg_trans_affine.o \
        agg_trans_double_path.o \
        agg_trans_single_path.o \
        agg_trans_warp_magnifier.o \
        agg_vcgen_bspline.o \
        agg_vcgen_contour.o \
        agg_vcgen_dash.o \
        agg_vcgen_markers_term.o \
        agg_vcgen_smooth_poly1.o \
        agg_vcgen_stroke.o \
        agg_vpgen_clip_polygon.o \
        agg_vpgen_clip_polyline.o \
        agg_vpgen_segmentator.o \

default: install

libagg.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

distclean: clean

clean:
	rm -f libagg.a *.o

$(PREFIX)/lib/libagg.a: libagg.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp -p libagg.a $(PREFIX)/lib/
	cp -p include/*.h $(PREFIX)/include/

install: $(PREFIX)/lib/libagg.a

%.o: src/%.cpp
	$(CXX) -c $(CXXFLAGS) src/$*.cpp -o $@

=== 3rdparty/ffmpeg/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 5.1.4
FFMPEG_EXTRA_CONFIGURE_FLAGS ?=
ifeq ($(shell uname),Darwin)
FFMPEG_EXTRA_CONFIGURE_FLAGS += --extra-cflags=-mmacosx-version-min=10.15
else ifeq ($(shell uname),Linux)
FFMPEG_EXTRA_CONFIGURE_FLAGS += --extra-cflags=-Wno-error=incompatible-pointer-types
endif


# build for ARMv7 w/ FPU support when using armv8l and requested build arch is armhf
ifeq ($(shell uname -m),armv8l)
ifeq ($(DEB_BUILD_ARCH),armhf)
FFMPEG_EXTRA_CONFIGURE_FLAGS += --cpu=armv7-a+fp
endif
endif


ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/ffmpeg-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/ffmpeg-$(VERSION).tar.gz

$(PREFIX)/src/ffmpeg-$(VERSION)/configure: $(PREFIX)/src/ffmpeg-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf ffmpeg-$(VERSION).tar.gz
	sed 's/    \(bcrypt\|clock_gettime\)//' $(PREFIX)/src/ffmpeg-$(VERSION)/configure > $(PREFIX)/src/ffmpeg-$(VERSION)/configure.tmp
	mv $(PREFIX)/src/ffmpeg-$(VERSION)/configure.tmp $(PREFIX)/src/ffmpeg-$(VERSION)/configure
	cd $(PREFIX)/src/ffmpeg-$(VERSION)/libavformat && patch -p1 < $(CURDIR)/mov_pixeldensity.patch
	chmod +x $(PREFIX)/src/ffmpeg-$(VERSION)/configure

$(PREFIX)/src/ffmpeg-$(VERSION)/Makefile: $(PREFIX)/src/ffmpeg-$(VERSION)/configure $(PREFIX)/lib/libtheora.a $(PREFIX)/lib/libvpx.a $(PREFIX)/lib/libopenh264.a
	cd $(PREFIX)/src/ffmpeg-$(VERSION) && \
	PKG_CONFIG_PATH=$(PREFIX)/lib/pkgconfig ./configure \
		--prefix=$(PREFIX) \
		--disable-x86asm \
		--disable-asm \
		--enable-static \
		--disable-shared \
		--enable-pic \
		--enable-libvpx \
		--enable-libtheora \
		--enable-libopenh264 \
		--disable-iconv \
		--extra-cflags=-I$(PREFIX)/include \
		--extra-cxxflags=-I$(PREFIX)/include \
		--extra-ldflags=-L$(PREFIX)/lib \
		--disable-doc \
		--disable-vaapi \
		--disable-postproc \
		--disable-network \
		--disable-programs \
		--disable-encoders \
		--disable-decoders \
		--disable-muxers \
		--disable-demuxers \
		--disable-parsers \
		--disable-bsfs \
		--disable-protocols \
		--disable-devices \
		--disable-filters \
		--disable-vdpau \
		--disable-dxva2 \
		--enable-encoder=libvpx_vp8 \
		--enable-encoder=libtheora \
		--enable-encoder=libopenh264 \
		--enable-encoder=gif \
		--enable-encoder=apng \
		--enable-muxer=webm \
		--enable-muxer=mov \
		--enable-muxer=mp4 \
		--enable-muxer=ogg \
		--enable-muxer=gif \
		--enable-muxer=apng \
		--enable-protocol=file \
		$(FFMPEG_EXTRA_CONFIGURE_FLAGS)
	# configure doesn't update the Makefile mtime correctly
	touch $@

$(PREFIX)/lib/libavformat.a: $(PREFIX)/src/ffmpeg-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/src/ffmpeg-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/src/ffmpeg-$(VERSION) install

install: $(PREFIX)/lib/libavformat.a


$(PREFIX)/lib/libtheora.a:
	$(MAKE) -C ../theora PREFIX="$(PREFIX)" install

$(PREFIX)/lib/libvpx.a:
	$(MAKE) -C ../vpx PREFIX="$(PREFIX)" install

$(PREFIX)/lib/libopenh264.a:
	$(MAKE) -C ../openh264 PREFIX="$(PREFIX)" install

.PHONY: default install

=== 3rdparty/freetype/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

 FTDEFINES = -DFT2_BUILD_LIBRARY -DDARWIN_NO_CARBON \
             '-DFT_CONFIG_MODULES_H="slimftmodules.h"' \
             '-DFT_CONFIG_OPTIONS_H="slimftoptions.h"'
FTINCLUDES = -Isrc -Iinclude
  FTCFLAGS = -O -fPIC -fno-common $(FTINCLUDES) $(FTDEFINES) $(ARCHS)

ifeq ($(shell uname -s),Darwin)
 FTCFLAGS += -mmacosx-version-min=10.15
endif

      OBJS = \
        ftbase.o \
        ftbbox.o \
        ftbitmap.o \
        ftdebug.o \
        ftgasp.o \
        ftglyph.o \
        ftinit.o \
        ftstroke.o \
        ftsynth.o \
        ftsystem.o \
        fttype1.o \
        ftmm.o \
        cff.o \
        psaux.o \
        pshinter.o \
        psnames.o \
        raster.o \
        sfnt.o \
        smooth.o \
        truetype.o \
        type1.o \
        type1cid.o

default: install

libfreetype.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

%.o: src/base/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/cff/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/cid/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/psaux/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/pshinter/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/psnames/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/raster/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/smooth/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/sfnt/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/truetype/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/type1/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<

distclean: clean

clean:
	rm -f libfreetype.a *.o

$(PREFIX)/lib/libfreetype.a: libfreetype.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp libfreetype.a $(PREFIX)/lib/
	cp include/ft2build.h $(PREFIX)/include/
	cp -r include/freetype $(PREFIX)/include/

install: $(PREFIX)/lib/libfreetype.a

.PHONY: default install clean distclean

=== 3rdparty/glfw/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 3.3.3
GLFW_EXTRA_CMAKE_FLAGS ?=
ifeq ($(shell uname),Darwin)
 GLFW_EXTRA_CMAKE_FLAGS += -DCMAKE_OSX_DEPLOYMENT_TARGET=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

ifeq ($(CMAKE_CMD),)
ifneq ($(shell cmake --version 2>/dev/null),)
CMAKE_CMD := cmake
CMAKE_DEP :=
endif
endif
ifeq ($(CMAKE_CMD),)
CMAKE_CMD := $(PREFIX)/bin/cmake
CMAKE_DEP := $(CMAKE_CMD)
endif

default: install

$(PREFIX)/src/glfw-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/glfw-$(VERSION).tar.gz

$(PREFIX)/src/glfw-$(VERSION)/CMakeLists.txt: $(PREFIX)/src/glfw-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf glfw-$(VERSION).tar.gz
	touch $@

$(PREFIX)/build/glfw-$(VERSION)/Makefile: $(PREFIX)/src/glfw-$(VERSION)/CMakeLists.txt $(CMAKE_DEP)
	mkdir -p $(PREFIX)/build/glfw-$(VERSION)
	cd $(PREFIX)/build/glfw-$(VERSION) && \
	$(CMAKE_CMD) \
		-DCMAKE_INSTALL_PREFIX:PATH=${PREFIX} \
		-DCMAKE_INSTALL_LIBDIR=lib \
		-DGLFW_USE_RETINA=OFF \
		-DGLFW_BUILD_EXAMPLES=OFF \
		-DGLFW_BUILD_DOCS=OFF \
		-DGLFW_BUILD_TESTS=OFF \
		$(GLFW_EXTRA_CMAKE_FLAGS) \
		$(PREFIX)/src/glfw-$(VERSION)/

$(PREFIX)/lib/libglfw3.a: $(PREFIX)/build/glfw-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/build/glfw-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/build/glfw-$(VERSION) install

install: $(PREFIX)/lib/libglfw3.a

.PHONY: default install

=== 3rdparty/icu/Makefile ===
SHELL := /bin/bash

ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 74.2
ICU_EXTRA_CONFIGURE_FLAGS ?=
ifeq ($(shell uname),Darwin)
ICU_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
ICU_EXTRA_CONFIGURE_FLAGS += CXXFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -f -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

ifeq ($(shell [[ "$(ARCH)" == "x86_64" || "$(ARCHS)" == "-arch x86_64" ]] && echo macos_cross),macos_cross)
default: run_macos_x86_64_cross_makefile
else ifeq ($(shell [[ "$(CC)" =~ -mingw ]] && echo mingw),mingw)
default: run_mingw_makefile
else
default: install
endif

run_macos_x86_64_cross_makefile:
	$(MAKE) -f Makefile.macos_x86_64_cross

run_mingw_makefile:
	$(MAKE) -f Makefile.mingw

$(PREFIX)/src/icu4c-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/icu4c-$(VERSION).tar.gz

$(PREFIX)/src/icu/source/configure: $(PREFIX)/src/icu4c-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf icu4c-$(VERSION).tar.gz

$(PREFIX)/src/icu/source/Makefile: $(PREFIX)/src/icu/source/configure
	cd $(PREFIX)/src/icu/source && \
	CFLAGS="-fPIC" \
	CXXFLAGS="-fPIC" \
	./configure \
		--prefix=$(PREFIX) \
		--enable-static \
		--disable-shared \
		$(ICU_EXTRA_CONFIGURE_FLAGS)
	touch $@

$(PREFIX)/lib/libicuuc.a: $(PREFIX)/src/icu/source/Makefile
	$(MAKE) -C $(PREFIX)/src/icu/source -j4
	$(MAKE) -C $(PREFIX)/src/icu/source install

libicuuc.a: $(PREFIX)/lib/libicuuc.a
	cp $(PREFIX)/lib/libicuuc.a libicuuc.a
	cp $(PREFIX)/lib/libicudata.a libicudata.a

clean:
	rm -f libicuuc.a
	rm -f libicudata.a

install: $(PREFIX)/lib/libicuuc.a

.PHONY: default clean install run_macos_x86_64_cross_makefile run_mingw_makefile

=== 3rdparty/jpeg/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

  CFLAGS = -O -I. -fPIC -fno-common $(ARCHS)
ifeq ($(shell uname),Darwin)
ifneq ($(notdir $(CC)),emcc)
 CFLAGS += -mmacosx-version-min=10.15
endif
endif
    OBJS = \
        jaricom.o \
        jcapimin.o \
        jcapistd.o \
        jcarith.o \
        jccoefct.o \
        jccolor.o \
        jcdctmgr.o \
        jchuff.o \
        jcinit.o \
        jcmainct.o \
        jcmarker.o \
        jcmaster.o \
        jcomapi.o \
        jcparam.o \
        jcprepct.o \
        jcsample.o \
        jctrans.o \
        jdapimin.o \
        jdapistd.o \
        jdarith.o \
        jdatadst.o \
        jdatasrc.o \
        jdcoefct.o \
        jdcolor.o \
        jddctmgr.o \
        jdhuff.o \
        jdinput.o \
        jdmainct.o \
        jdmarker.o \
        jdmaster.o \
        jdmerge.o \
        jdpostct.o \
        jdsample.o \
        jdtrans.o \
        jerror.o \
        jfdctflt.o \
        jfdctfst.o \
        jfdctint.o \
        jidctflt.o \
        jidctfst.o \
        jidctint.o \
        jmemmgr.o \
        jmemnobs.o \
        jquant1.o \
        jquant2.o \
        jutils.o

default: install

libjpeg.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

distclean: clean

clean:
	rm -f libjpeg.a *.o *.bak

$(PREFIX)/lib/libjpeg.a: libjpeg.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp libjpeg.a $(PREFIX)/lib/
	cp *.h $(PREFIX)/include/

install: $(PREFIX)/lib/libjpeg.a

depend:
	makedepend -Y -- \
        jaricom.c \
        jcapimin.c \
        jcapistd.c \
        jcarith.c \
        jccoefct.c \
        jccolor.c \
        jcdctmgr.c \
        jchuff.c \
        jcinit.c \
        jcmainct.c \
        jcmarker.c \
        jcmaster.c \
        jcomapi.c \
        jcparam.c \
        jcprepct.c \
        jcsample.c \
        jctrans.c \
        jdapimin.c \
        jdapistd.c \
        jdarith.c \
        jdatadst.c \
        jdatasrc.c \
        jdcoefct.c \
        jdcolor.c \
        jddctmgr.c \
        jdhuff.c \
        jdinput.c \
        jdmainct.c \
        jdmarker.c \
        jdmaster.c \
        jdmerge.c \
        jdpostct.c \
        jdsample.c \
        jdtrans.c \
        jerror.c \
        jfdctflt.c \
        jfdctfst.c \
        jfdctint.c \
        jidctflt.c \
        jidctfst.c \
        jidctint.c \
        jmemmgr.c \
        jmemnobs.c \
        jquant1.c \
        jquant2.c \
        jutils.c 2> /dev/null

.PHONY: default install clean distclean depend

# DO NOT DELETE THIS LINE -- make depend depends on it.

jaricom.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcapimin.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcapistd.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcarith.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jccoefct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jccolor.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcdctmgr.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jchuff.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcinit.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcmainct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcmarker.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcmaster.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcomapi.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcparam.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcprepct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcsample.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jctrans.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdapimin.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdapistd.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdarith.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdatadst.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdatasrc.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdcoefct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdcolor.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jddctmgr.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jdhuff.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdinput.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdmainct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdmarker.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdmaster.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdmerge.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdpostct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdsample.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdtrans.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jerror.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jversion.h
jfdctflt.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jfdctfst.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jfdctint.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jidctflt.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jidctfst.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jidctint.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jmemmgr.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jmemsys.h
jmemnobs.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jmemsys.h
jquant1.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jquant2.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jutils.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h

=== 3rdparty/ogg/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 1.3.2
OGG_EXTRA_CONFIGURE_FLAGS ?=
ifeq ($(shell uname),Darwin)
OGG_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/libogg-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/libogg-$(VERSION).tar.gz

$(PREFIX)/src/libogg-$(VERSION)/configure: $(PREFIX)/src/libogg-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf libogg-$(VERSION).tar.gz
	touch $@

$(PREFIX)/src/libogg-$(VERSION)/Makefile: $(PREFIX)/src/libogg-$(VERSION)/configure
	cd $(PREFIX)/src/libogg-$(VERSION) && \
	./configure \
		--prefix=$(PREFIX) \
		--libdir=$(PREFIX)/lib \
		--enable-static \
		--disable-shared \
		--with-pic \
		--disable-dependency-tracking \
		$(OGG_EXTRA_CONFIGURE_FLAGS)

$(PREFIX)/lib/libogg.a: $(PREFIX)/src/libogg-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/src/libogg-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/src/libogg-$(VERSION) install

install: $(PREFIX)/lib/libogg.a

.PHONY: default install

=== 3rdparty/zeromq/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 4.3.4
ZEROMQ_EXTRA_CONFIGURE_FLAGS ?=

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/zeromq-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/zeromq-$(VERSION).tar.gz

$(PREFIX)/src/zeromq-$(VERSION)/configure: $(PREFIX)/src/zeromq-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf zeromq-$(VERSION).tar.gz
	cd $(PREFIX)/src/zeromq-$(VERSION) && patch -p1 < $(CURDIR)/tests_includes.patch
	cd $(PREFIX)/src/zeromq-$(VERSION) && patch -p1 < $(CURDIR)/tests_pointer_comparison.patch
	cd $(PREFIX)/src/zeromq-$(VERSION) && patch -p1 < $(CURDIR)/snprintf.patch
	touch $@

$(PREFIX)/src/zeromq-$(VERSION)/Makefile: $(PREFIX)/src/zeromq-$(VERSION)/configure
	cd $(PREFIX)/src/zeromq-$(VERSION) && \
	./configure \
		--prefix=$(PREFIX) \
		--libdir=$(PREFIX)/lib \
		--enable-static \
		--disable-shared \
		--with-pic \
		--disable-dependency-tracking \
		--enable-curve=no \
		$(ZEROMQ_EXTRA_CONFIGURE_FLAGS)

$(PREFIX)/lib/libzmq.a: $(PREFIX)/src/zeromq-$(VERSION)/Makefile
	MACOSX_DEPLOYMENT_TARGET="10.15" $(MAKE) -C $(PREFIX)/src/zeromq-$(VERSION) -j4
	MACOSX_DEPLOYMENT_TARGET="10.15" $(MAKE) -C $(PREFIX)/src/zeromq-$(VERSION) install

install: $(PREFIX)/lib/libzmq.a

distclean: clean

clean:
	rm -f libzmq.a *.o

.PHONY: default install clean distclean

=== lib/gr/Makefile ===
ifeq ($(strip $(THIRDPARTYDIR)),)
override THIRDPARTYDIR = $(abspath $(CURDIR)/../../3rdparty/build)
endif

       GRDIR = /usr/local/gr
      BINDIR = $(DESTDIR)$(GRDIR)/bin
      LIBDIR = $(DESTDIR)$(GRDIR)/lib
      INCDIR = $(DESTDIR)$(GRDIR)/include

UNAME := $(shell uname)

      GROBJS = gr.o text.o contour.o spline.o gridit.o strlib.o stream.o image.o \
               delaunay.o interp2.o md5.o import.o shade.o grforbnd.o \
               contourf.o boundary.o mathtex2.o mathtex2_kerning.o mathtex2.tab.o threadpool.o
      GSDEFS =
     DEFINES = $(GSDEFS) -DGRDIR=\"$(GRDIR)\"
    INCLUDES = -I../gks -I$(THIRDPARTYDIR)/include
          CC = cc
      CFLAGS = $(DEFINES) -O3 -Wall -Wextra -ansi -pedantic -fPIC $(EXTRA_CFLAGS)
          AR = ar
      RANLIB = ar ts
ifeq ($(UNAME), Darwin)
GR_SHARED_LIBRARY_SUFFIX ?= .dylib
	 CFLAGS += -mmacosx-version-min=10.15
INSTALL_NAME = -Wl,-install_name,@rpath/libGR${GR_SHARED_LIBRARY_SUFFIX}
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,@loader_path/. -mmacosx-version-min=10.15
     SOFLAGS = -dynamiclib
else
GR_SHARED_LIBRARY_SUFFIX ?= .so
INSTALL_NAME =
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,'$$ORIGIN/.'
     SOFLAGS = -shared
endif
        LIBS = -lpthread -ldl -lc -lm
    JPEGLIBS = $(THIRDPARTYDIR)/lib/libjpeg.a
     BZ2LIBS = $(THIRDPARTYDIR)/lib/libbz2.a
     PNGLIBS = $(THIRDPARTYDIR)/lib/libpng.a
     GKSLIBS = ../gks/libGKS.a
      FTLIBS = $(THIRDPARTYDIR)/lib/libfreetype.a
       ZLIBS = $(THIRDPARTYDIR)/lib/libz.a
      QHLIBS = $(THIRDPARTYDIR)/lib/libqhull_r.a

# Only update gr_version.h if it will result in an actual change
GR_VERSION_H_GENERATED := $(shell ../../lib/Version)
GR_VERSION_H_CURRENT := $(shell cat gr_version.h 2>/dev/null || echo "")
ifneq ($(GR_VERSION_H_CURRENT),$(GR_VERSION_H_GENERATED))
GR_VERSION_H_DEPS := .FORCE
else
GR_VERSION_H_DEPS :=
endif

.SUFFIXES:
.SUFFIXES: .c .o

.c.o:
	$(CC) -c $(INCLUDES) $(CFLAGS) $<

default:
	$(MAKE) -C ../.. Makedefs
	$(MAKE) `cat ../../Makedefs`

all: targets

targets: prerequisites libGR.a libGR${GR_SHARED_LIBRARY_SUFFIX} demo libqtgr

prerequisites:
	$(MAKE) -C ../../3rdparty/ PREFIX=$(THIRDPARTYDIR)

../gks/libGKS.a:
	$(MAKE) -C ../gks libGKS.a

libGR.a: $(GROBJS)
	$(AR) crv $@ $?
	$(RANLIB) $@

libGR${GR_SHARED_LIBRARY_SUFFIX}: $(GROBJS) $(GKSLIBS)
	$(CC) -o $@ $(SOFLAGS) $(GROBJS) $(PNGLIBS) $(GKSLIBS) \
	$(FTLIBS) $(JPEGLIBS) $(ZLIBS) $(QHLIBS) $(LIBS) \
	$(LDFLAGS) $(INSTALL_NAME)

demo: demo.c libGR.a $(GKSLIBS)
	$(CC) -o demo $(INCLUDES) $(CFLAGS) demo.c libGR.a \
	$(PNGLIBS) $(GKSLIBS) $(FTLIBS) $(JPEGLIBS) \
	$(ZLIBS) $(QHLIBS) $(LIBS) $(LDFLAGS)

libqtgr:
	$(MAKE) -C qtgr

gr_version.h: $(GR_VERSION_H_DEPS)
	../../lib/Version > $@
	@chmod 644 $@

gr.o: gr_version.h

install:
	$(MAKE) -C ../gks install
	@if [ ! -d $(DESTDIR)$(GRDIR) ]; then mkdir -m 755 $(DESTDIR)$(GRDIR); fi
	@if [ ! -d $(BINDIR) ]; then mkdir -m 755 $(BINDIR); fi
	@if [ ! -d $(LIBDIR) ]; then mkdir -m 755 $(LIBDIR); fi
	cp -p libGR.* $(LIBDIR)
	@if [ ! -d $(INCDIR) ]; then mkdir -m 755 $(INCDIR); fi
	cp -p gr.h $(INCDIR)
	$(MAKE) -C qtgr install

clean:
	$(MAKE) -C qtgr clean
	$(MAKE) -C ../gks clean
	$(MAKE) -C ../gks/plugin clean
	$(MAKE) -C ../../3rdparty/ clean
	rm -f so_locations demo *.so *.a *.o *.bak *~ gr_version.h *${GR_SHARED_LIBRARY_SUFFIX}

depend:
	makedepend -Y -- gr.c text.c contour.c spline.c gridit.c strlib.c stream.c \
	image.c delaunay.c interp2.c md5.c import.c shade.c grforbnd.c \
    threadpool.c    2> /dev/null

.FORCE:

.PHONY: all targets install clean depend prerequisites .FORCE

# DO NOT DELETE THIS LINE -- make depend depends on it.

gr.o: gr.h text.h spline.h gridit.h contour.h strlib.h stream.h md5.h cm.h
contour.o: gr.h contour.h
contourf.o: gr.h contourf.h
spline.o: spline.h
gridit.o: gridit.h
strlib.o: strlib.h
io.o: gr.h stream.h
image.o: gr.h
delaunay.o: gr.h
interp2.o: gr.h
md5.o: md5.h
import.o: gr.h
shade.o: gr.h
grforbnd.o: gr.h
boundary.o: boundary.h
mathtex2.o: mathtex2.h tempbuffer.inl
mathtex2.tab.o: mathtex2.h
threadpool.o: threadpool.h

=== PKGBUILD ===
# Maintainer: Sutou Kouhei <kou@clear-code.com>

_realname=gr
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=0.73.7
pkgrel=2
pkgdesc="A graphics library for visualisation applications (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://gr-framework.org/"
msys2_repository_url="https://github.com/sciapp/gr"
msys2_references=(
  'aur: gr-framework'
)
license=("spdx:MIT")
depends=("${MINGW_PACKAGE_PREFIX}-bzip2"
         "${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-glfw"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-qhull"
         "${MINGW_PACKAGE_PREFIX}-qt5-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zeromq")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/sciapp/gr/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('2584727b1413a337ef14daae1e61bdc5c946403031695b42ecfbf8bc1888d132')
noextract=("${_realname}-${pkgver}.tar.gz")

prepare() {
  # We can't use bsdtar to extract the archive because the archive includes
  # symbolic link.
  rm -rf "${_realname}-${pkgver}"
  tar -xf "${_realname}-${pkgver}.tar.gz" || true

  cd "${srcdir}/${_realname}-${pkgver}"

  # Set version manually, otherwise it resets to zero
  echo "${pkgver}" > version.txt
  sed -i "s|\${GR_VERSION}|${pkgver}|g" CMakeLists.txt
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DGR_USE_BUNDLED_LIBRARIES=OFF \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.md "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.md"
}
